% CSC320S 2005: Assignment 2
%
% Student: Jason Montojo 
% Username: g2cookie@cdf

function ims = morphImages(im0, im1, linePairs, s)
% ims = morphImages(im0, im1, linePairs, s)
%
% Returns the image of the morphs from im0 into im1 at time s,
% given the control lines in linePairs.  The morph is computed using array
% operations.
%
%   s must be in [0, 1].
%
%   im0 and im1 must have the same dimensions.
%
%   linePairs is an 8xj matrix where j is the number of line segment pairs.
%   Each column of linePairs is of the form:
%
%     [Px0 Py0 Qx0 Qy0 Px1 Py1 Qx1 Qy1]'
%
%   ... where P0Q0 is a segment in im0 which corresponds to
%   P1Q1, a segment in im1.

a = eps;
b = 2;
p = 0.5;

[W0, W1] = morphWarps(linePairs, size(im0), s, a, b, p);
[x, y] = meshgrid(1:size(im0, 2), 1:size(im0, 1));
ims = (1 - s) * interp2(x, y, im0, W0(:, :, 1), W0(:, :, 2), 'cubic') ...
          + s * interp2(x, y, im1, W1(:, :, 1), W1(:, :, 2), 'cubic');
